#include "cErrorLogbook.hpp"

#include "icbcErrorHandler.hpp"

#include "../../Platform/Hardware_Abstraction/imBasicIO.hpp"
using namespace Platform::Hardware_Abstraction;


namespace Common::Management
{
	cErrorLogbook::cErrorLogbook(const uint32_t ObjectID, Common::Management::icbcErrorHandler* const ptrErrorHandler) :
		mObjectID{ ObjectID },
		mPtrErrorHandler{ ptrErrorHandler }
	{
		showValue("\nCommon::Management::cErrorLogbook - Object ID = ", mObjectID);
	}

	cErrorLogbook::~cErrorLogbook()
	{
		showValue("\nCommon::Management::~cErrorLogbook");
	}

	void cErrorLogbook::addErrorEntry(const cErrorEntry ErrorEntry)
	{
		mErrorEntryContainer.push_back(ErrorEntry);
	}

	void cErrorLogbook::show(void)
	{
		for (const auto& refErrorEntry : mErrorEntryContainer)
		{
			showValue("\nObject ID: ", refErrorEntry.getErrorObjectID() ,
				      " -> Error: ", static_cast<uint32_t>(refErrorEntry.getError()));
		}
	}
}
