#ifndef __cAEnManager_HPP__
#define __cAEnManager_HPP__

#include "../Common/Management/icbcErrorHandler.hpp"
#include "../Common/Management/icAEnManager.hpp"
#include "../AEn/cN.hpp"

namespace Common::Management { class icDignostics; }
namespace Common::Management { class icErrorLogbook; }

namespace AEn
{
	class cAEnManager : public Common::Management::icbcErrorHandler,
		                public Common::Management::icAEnManager
	{
		public:
			explicit cAEnManager(const uint32_t ObjectID);
			~cAEnManager() override;
		
		private:
			void create(void) override;
			void init(void) override;
			void deinit(void) override;
			void buildRelations(void) override;
			void resetRelations(void) override;
			void config(uint32_t const Data) override;
			void allocateResources(void) override;
			void deallocateResources(void) override;
			void start(void) override;
			void taskInit(void) override;
			void taskOperational(void) override;

			void executeDiagnostics(void) override;

			void restart(void) override;
			void shutdown(void) override;
			void registerErrorHandler(icbcErrorHandler* const ptrNextLevelErrorHandler) override;
			void enterFailSafe(void) override;

			void notifyError(const uint32_t ObjectID, const Common::Management::ecError Error) override;
			void handleError(void);
			void recoverError(void);

		private:
			static const uint32_t mObjectID_Diagnostics = 5;
			static const uint32_t mObjectID_ErrorLogbook = 6;
			static const uint32_t mObjectID_mN = 7;
			const uint32_t mObjectID;

			icbcErrorHandler* mPtrUpperLevelErrorHandler{ nullptr };
			Common::Management::icDiagnostics* mPtrDiagnostics{ nullptr };
			Common::Management::icErrorLogbook* mPtrErrorLogbook{ nullptr };
			
			AEn::cN mN;
	};
}

#endif  // __cAEnManager_HPP__
