#include "cN.hpp"

#include "../../Platform/Hardware_Abstraction/imBasicIO.hpp"
using namespace Platform::Hardware_Abstraction;

namespace AEn
{
	cN::cN(const uint32_t ObjectID) :
		mObjectID{ ObjectID }
	{
		showValue("\ncN::cN - Object ID = ", mObjectID);
	}

	cN::~cN()
	{
		showValue("\ncN::~cN");
	}

	void cN::init(void)
	{
		showValue("\ncN::init");
	}

	void cN::deinit(void)
	{
		showValue("\ncN::deinit");
	}

	void cN::buildRelations(void)
	{
		showValue("\ncN::buildRelations");
	}

	void cN::config(uint32_t const Data)
	{
		showValue("\ncN::config");
		
		mConfigData = Data;

		mPtrErrorHandler->notifyError(mObjectID, Common::Management::ecError::Error_1);
		mPtrErrorHandler->notifyError(mObjectID, Common::Management::ecError::Error_2);
	}

	void cN::taskOperational(void)
	{
		showValue("\ncN::taskOperational");
	}

	Common::Management::cDiagnosticsEntry cN::getDiagnostics(void) const
	{
		showValue("\ncN::getDiagnosticData");

		const Common::Management::cDiagnosticsEntry locDiagnosticeEntry{ mObjectID, mDiagnosticsData };
		
		return locDiagnosticeEntry;
	}

	void cN::registerErrorHandler(Common::Management::icbcErrorHandler* const ptrNextLevelErrorHandler)
	{
		showValue("\ncN::registerErrorHandler");

		mPtrErrorHandler = ptrNextLevelErrorHandler;
	}
}
