#include "cDiagnostics.hpp"

#include "../../Platform/Hardware_Abstraction/imBasicIO.hpp"
using namespace Platform::Hardware_Abstraction;

namespace Common::Management
{
	cDiagnostics::cDiagnostics(const uint32_t ObjectID, Common::Management::icbcErrorHandler* const ptrErrorHandler) :
		mObjectID{ ObjectID },
		mPtrErrorHandler{ ptrErrorHandler }
	{
		showValue("\nCommon::Management::cDiagnostics - Object ID = ", mObjectID);
	}

	cDiagnostics::~cDiagnostics()
	{
		showValue("\nCommon::Management::~cDiagnostics");
	}

	void cDiagnostics::write(const uint32_t Index, const cDiagnosticsEntry DiagnosticsEntry)
	{
		mDiagnosticsContainer[Index] = DiagnosticsEntry;
	}

	cDiagnosticsEntry cDiagnostics::read(const uint32_t Index) const
	{
		return mDiagnosticsContainer[Index];
	}

	void cDiagnostics::show(void) const
	{
		for (auto&& refElement : mDiagnosticsContainer)
		{
			showValue("\nObject ID: ", refElement.getDiagnosticsObjectID(),
				" -> Diagnostics: ", refElement.getDiagnosticsData());
		}
	}

	uint32_t cDiagnostics::getMaxNumberOfDiagnosticsEntries(void) const
	{
		return mMaxNumberOfDiagnosticEntries;
	}
}
