#ifndef __cDiagnostics_HPP__
#define __cDiagnostics_HPP__

#include "icDiagnostics.hpp"

#include <array>

namespace Common::Management
{
	class icbcErrorHandler;
	
	class cDiagnostics : public icDiagnostics
	{
		public:
			explicit cDiagnostics(const uint32_t ObjectID, Common::Management::icbcErrorHandler* const ptrErrorHandler);
			~cDiagnostics();

			void write(const uint32_t Index, const cDiagnosticsEntry DiagnosticsEntry) override;
			cDiagnosticsEntry read(const uint32_t Index) const override;
			void show(void) const override;
			
			uint32_t getMaxNumberOfDiagnosticsEntries(void) const;

		private:
			static const uint32_t mMaxNumberOfDiagnosticEntries = 10;

			const uint32_t mObjectID;
			Common::Management::icbcErrorHandler* mPtrErrorHandler{ nullptr };
			std::array<cDiagnosticsEntry, mMaxNumberOfDiagnosticEntries> mDiagnosticsContainer{ };
	};
}

#endif  // __cDiagnostics_HPP__
