#ifndef __icAEnManager_HPP__
#define __icAEnManager_HPP__

#include "TypeDefinitions.hpp"

//#include "icDiagnostics.hpp"
#include "cDiagnosticsEntry.hpp"

#include <vector>

namespace Common::Management
{
	class icbcErrorHandler;
	class icDiagnostics;

	class icAEnManager
	{
		public:
			virtual void create(void) = 0;
			virtual void init(void) = 0;
			virtual void deinit(void) = 0;
			virtual void buildRelations(void) = 0;
			virtual void resetRelations(void) = 0;
			virtual void config(uint32_t const Data) = 0;
			virtual void allocateResources(void) = 0;
			virtual void deallocateResources(void) = 0;
			virtual void start(void) = 0;
			virtual void taskInit(void) = 0;
			virtual void taskOperational(void) = 0;
			virtual void executeDiagnostics(void) = 0;
			
			virtual void restart(void) = 0;
			virtual void shutdown(void) = 0;
			virtual void registerErrorHandler(icbcErrorHandler* const ptrNextLevelErrorHandler) = 0;
			virtual void enterFailSafe(void) = 0;

		protected:
			icAEnManager() = default;
			virtual ~icAEnManager() = default;
	};
}

#endif  // __icAEnManager_HPP__
