#include "cDataBase.hpp"

#include "../Common/Management/icbcErrorHandler.hpp"

#include "../../Platform/Hardware_Abstraction/imBasicIO.hpp"
using namespace Platform::Hardware_Abstraction;

namespace Software_Management
{
	cDataBase::cDataBase(const uint32_t ObjectID, Common::Management::icbcErrorHandler* const ptrErrorHandler) :
		mObjectID{ ObjectID },
		mPtrErrorHandler{ ptrErrorHandler }
	{
		showValue("\nSoftware_Management::cDataBase - Object ID = ", mObjectID);
	}

	cDataBase::~cDataBase()
	{
		showValue("\nSoftware_Management::~cDataBase");
	}

	void cDataBase::setData(uint32_t const Data)
	{
		mData = Data;
	}

	uint32_t cDataBase::getData(void) const
	{
		return mData;
	}
}
