#ifndef __ivtmDebugOutput_HPP__
#define __ivtmDebugOutput_HPP__

#include <iostream>

namespace Platform
{
	namespace Hardware_Abstraction
	{
		void showValue(void)
		{
			std::cout << std::endl;
		}

		template<typename Type_T, typename... OtherTypes_T>
		void showValue(Type_T Argument_0, OtherTypes_T... Other_Arguments)
		{
			std::cout << Argument_0 << " ";
			showValue(Other_Arguments...);
		}

		// since C++17 fold expressions are supported
		/*template <typename... Type_T>
		void showValue(Type_T const&... Arguments)
		{
			(std::cout << ... << Arguments) << std::endl;
		}*/
	}
}

#endif // #ifndef __ivtmDebugOutput_HPP__
